Request

Response

    Searches among the parameters in a parameter collection.
    POST

    v1/accounts/:accountId/groups/:groupId/collections/:collectionId/parameters:search

    Searches among the parameters in a parameter collection.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/parameters/v1/accounts/:accountId/groups/:groupId/collections/:collectionId/parameters:search
    Authentication Context
    user context required
    Required OAuth Scopes
    data:search
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is obtained via a three-legged OAuth flow.
    Content-Type*
    string
    Must be application/json
    Region
    string
    The region the hub’s data is provisioned in. Currently supports US, EMEA, AUS, IND, DEU, JPN, CAN, and GBR. Default is US.
    * Required

    Request

    URI Parameters

    accountId
    string: UUID or string: b.UUID
    The Autodesk Forma hub ID.
    groupId
    string
    The group ID. Currently, only one group is supported, and group id is equal to hub id. (Supporting multiple groups is considered for future enhancement)
    collectionId
    string
    The collection ID.

    Request

    Query String Parameters

    offset
    int
    Offset from the start of the collection to the first entry in the page. Zero based.
    limit
    int
    Determines the maximum number of objects that MAY be returned. A query MAY return fewer than the value of limit due to filtering or other reasons..

    Request

    Body Structure

    searchedText
    string
    The searched text. Search only checks for results in the parameter name.
    sort
    enum:string
    The sort method. Possible values: NAME_ASCENDING, NAME_DESCENDING,

    CREATED_ASCENDING, CREATED_DESCENDING, MODIFIED_ASCENDING, MODIFIED_DESCENDING.

    labelIds
    array: string
    The label IDs. Lookup the label ID in the response of the GET /labels API.
    groupBindingId
    string
    The group ID. Lookup the group ID in the response of the GET /classifications/groups API.
    dataTypeIds
    array: string
    The parameter data type IDs. It could be either a parameter spec ID or a category ID. When used as a “data type” identifier, a category ID indicates the “Family Type” spec with that category.

    Lookup the spec ID in the response of the GET /specs API. Lookup the category ID in the response of the GET /classifications/categories API.

    categoryBindingIds
    array: string
    The classification category binding IDs. Look up detailed information in the response of the GET /classifications/categories API.
    isInstance
    boolean
    Indicates if the parameter is associated with element instances.
    isType
    boolean
    Indicates if the parameter is associated with element types.
    isHidden
    boolean
    Indicates if the parameter is hidden in the application user-interface.
    isReadOnly
    boolean
    Indicates if the parameter is to be treated as read-only or not by a UI client. Immutable once set.
    isArchived
    boolean
    Indicates if the parameters are archived or not.

    Response

    HTTP Status Code Summary

    200
    OK
    Successful search response for parameters.
    400
    Bad Request
    The request could not be understood by the server due to malformed syntax.
    401
    Unauthorized
    Request has not been applied because it lacks valid authentication credentials for the target resource.
    403
    Forbidden
    The server understood the request but refuses to authorize it.
    404
    Not Found
    The resource cannot be found.
    406
    Not Acceptable
    The server cannot produce a response matching the list of acceptable values defined in the request.
    410
    Access to the target resource is no longer available.
    429
    Too Many Requests
    User has sent too many requests in a given amount of time.
    500
    Internal Server Error
    An unexpected error occurred on the server.
    503
    Service Unavailable
    Server is not ready to handle the request.

    Response

    Body Structure (200)

    Expand all
    pagination
    object
    The information for paginating records returned by the endpoint.
    offset
    int
    Offset from the start of the collection to the first entry in the page. Zero based.
    limit
    int
    Determines the maximum number of objects that MAY be returned. A query MAY return fewer than the value of limit due to filtering or other reasons.
    totalResults
    int
    The total number of results that match the query irrespective of limit.
    nextUrl
    string
    Link that will return the next page of data. If not included, this is the last page of data.
    results
    array: object
    id
    string
    The parameter ID.
    name
    string
    The parameter’s name.
    description
    string
    The parameter description. The length of the parameter description is limited to 250 characters.
    specId
    string
    The parameter spec ID. See the field guide about the definition of spec.”
    readOnly
    boolean
    Indicates if the parameter is to be treated as read-only or not by a UI client. Immutable once set..
    metadata
    array: object
    The parameter metadata. It may vary from one product to another.
    For example, to support the use of a parameter in Revit, the metadata object might record category bindings and an instance/type assignment.
    anyOf
    0
    object
    An object with a string ID and a Boolean value. The ID could be one of the below:
    “isHidden” to indicate if the parameter is hidden or not in the application.
    “isArchived” to indicate if the parameter is archived or not.
    id
    string
    The metadata ID.
    value
    boolean
    Boolean value of the metadata.
    1
    object
    An object with a string ID and an enumerated string value. The ID could be “instanceTypeAssociation” to indicate if the parameter is associated with element instances, element types, or neither. Possible values: NONE, INSTANCE, TYPE
    id
    string
    The metadata ID.
    value
    string
    The metadata value.
    2
    object
    An object with a string ID and a string array value. The ID could be “labelIds” to list all the labels attached to this parameter.
    id
    string
    The metadata ID.
    value
    array: string
    The metadata value.
    3
    object
    An object with a string ID and an object value. The ID could be “group” to indicate the group for this parameter.
    id
    string
    The metadata ID.
    value
    object
    The metadata value.
    bindingId
    string
    The binding ID of the group, which can be looked up in the results of the GET /classifications/groups API.
    id
    string
    The group ID, which can be looked up in the results of the GET /classifications/groups API.
    4
    object
    An object with a string ID and an object value. The ID could be “categories” to indicate the categories of this parameter.
    id
    string
    The metadata ID.
    value
    array: object
    The metadata value.
    bindingId
    string
    The category binding ID, which can be looked up in the results of the GET /classifications/categories API.
    id
    string
    The category ID, which can be looked up in the results of the GET /classifications/categories API.
    5
    object
    An object with a string ID and a string value. The ID could be “specCategoryId” to indicate the spec category ID of this family type parameter.
    id
    string
    The metadata ID.
    value
    string
    The metadata value.
    valueTypeId
    string
    The identifier of the storage value type, which could be a primitive type ID, such as Bool, Int64, Float64, String, DateTime, URI, Date, or a complex type ID.
    errors
    array: object
    id
    string
    The resource ID.
    title
    string
    The error title.
    detail
    string
    The error detail.
    code
    string
    The error code.

    Note: Search APIs will return a (200) response even if it returns with errors in the response instead of a (207)

    Example

    Successful search for parameters (200).

    Request

    curl -v 'https://developer.api.autodesk.com/parameters/v1/accounts/d05ec054-ef80-46ad-9c80-fc742f29027c/groups/d05ec054-ef80-46ad-9c80-fc742f29027c/collections/028b3307-91aa-45ec-864c-1c4af88b8a08/parameters:search' \
      -X 'POST' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '{
            "searchedText": "Artificial",
            "isArchived": false,
            "sort": "NAME_ASCENDING"
          }'
    
    Show More

    Response

    {
      "pagination": {
        "offset": 0,
        "limit": 50,
        "totalResults": 21,
        "nextUrl": "https://developer.api.autodesk.com/parameters/v1/accounts/d05ec054-ef80-46ad-9c80-fc742f29027c/groups/d05ec054-ef80-46ad-9c80-fc742f29027c/collections/028b3307-91aa-45ec-864c-1c4af88b8a08/parameters:search?offset=50&limit=50"
      },
      "results": [
        {
          "id": "parameters.d05ec054ef8046ad9c80fc742f29027c:000ccf6716504165b73d20739f7dc1bf-1.0.0",
          "name": "ArtificialLighting",
          "description": ""
          "specId": "autodesk.spec:spec.string-2.0.0",
          "readOnly": false,
          "metadata": [
            {
              "id": "isHidden",
              "value": false
            },
            {
              "id": "isArchived",
              "value": false
            },
            {
              "id": "labelIds",
              "value": [
                "ACSF-01105-DTLK-44382",
                "ADJH-96226-GAKC-59763",
                "ACSY-84419-DPLC-36868"
              ]
            },
            {
              "id": "group",
              "value": null
            },
            {
              "id": "instanceTypeAssociation",
              "value": "TYPE"
            },
            {
              "id": "categories",
              "value": [
                {
                  "bindingId": "ACFT-94219-HCEE-04771",
                  "id": "autodesk.revit.category.family:doors-1.0.0"
                }
              ]
            },
            {
              "id": "specCategory",
              "value": null
            }
          ]
        },
      ]
    }
    
    Show More